<?php
require_once "PAPI/GPoA/Reader.php";
require_once "PAPI/GPoA/Log.php";
require_once "PAPI/GPoA/Crypt_AES.php";
require_once "PAPI/GPoA/Crypt_RSA.php";
require_once "PAPI/GPoA/GPoAHandler.php";
require_once "PAPI/GPoA/LCookManager.php";

class GPoAMain {

	public static function start($config) {
		Log::setConfig($config['LOG_MODE']['debug'], $config['LOG_MODE']['file']);
		Log::init();
		
		Log::debug("Message received");
		
		$gpoa_handler = new GPoAHandler();
		$gpoa_handler->processConfig($config);
		$lcook_manager = new LCookManager();
		$lcook_manager->processConfig($config);
		
		if ($gpoa_handler->isATTREQResponse($_REQUEST)) {
			Log::info("ATTREQ response message received");
			$response = $gpoa_handler->processATTREQResponse($_REQUEST);
			
			$lcook_manager->putLcook($response['assertion']);
		
			$checked_msg = $gpoa_handler->getCHECKEDResponse($response['old_params']['URL'], 
				$response['assertion'], $response['old_params']['DATA']);
			
			Log::info("Redirect -> ".$checked_msg);
			header("Location: ".$checked_msg);
		}
		else if ($gpoa_handler->isCHECKRequest($_REQUEST)) {
			Log::info("CHECK request message received");
			$lcook_data = $lcook_manager->getLcook();
			
			if ($lcook_manager->validLcook($lcook_data)) {
				$lcook_manager->putLcook($lcook_data['assertion']);
			
				$checked_msg = $gpoa_handler->getCHECKEDResponse($_REQUEST['URL'], $lcook_data['assertion'], $_REQUEST['DATA']);
		
				Log::info("Redirect -> ".$checked_msg);
				header("Location: ".$checked_msg);
			}
			else {
			
				$sel_as_id = '';
				if (array_key_exists('PAPIHLI', $_REQUEST)) {
					$sel_as_id = $_REQUEST['PAPIHLI'];
					Log::debug("PAPIHLI value: '".$sel_as_id."'");
				}
		
				if ($sel_as_id=='' && $gpoa_handler->isNeededWayf()) {
					Log::info("Showing WAYF");
					require_once("wayf/index.php");
				}
				else {
					// SAVE REQUEST
					$id = $gpoa_handler->saveRequest($_REQUEST);
		
					$attreq = $gpoa_handler->getATTREQRequest($id, $sel_as_id, $_REQUEST['URL']);
					
					Log::info("Redirect -> ".$attreq);
					header("Location: ".$attreq);
				}
		
			}
		}
	}
}

?>
