<?php
/*
 * Copyright (C) 2010 - PRiSE
 *
 * This	free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

class LCookManager {
	private $lcook_data;
	private $name_lcookie;

	public function processConfig($config) {
		$this->lcook_data = Reader::readParameter($config['LCOOK']);
		$this->name_lcookie = $this->lcook_data['L_NAME_PREFIX'].Reader::readParameter($config['ID_GPOA']);
	}

	public function getLkey() {
		if ($this->lcook_data['LKEY']!='') {
			return $this->lcook_data['LKEY'];
		}
		else {
			if (!isset($_SESSION)) {
				session_start();
			}
			if (!array_key_exists("lkey_value", $_SESSION)) {
				mt_srand((double)microtime()*1000000);
				$random = mt_rand();
				$_SESSION["lkey_value"] = md5($random);
			}
			return $_SESSION["lkey_value"];
		}
	}
	
	public function putLcook($assertion) {
		$random = mt_rand();
		$now = time();
		$location = $_SERVER['SCRIPT_NAME'];
		$server = $_SERVER['SERVER_NAME'];
		$raw = $random.":".$now.":".$location.":".$server.":".$assertion;
		$ciphered = Crypt_AES::encrypt_base64($raw, $this->getLkey());
		setcookie($this->name_lcookie, $ciphered, $now + $this->lcook_data['L_TTL']);
	}
	
	public function validLcook($lcook_data) {
		$location = $_SERVER['SCRIPT_NAME'];
		$server = $_SERVER['SERVER_NAME'];
		$now = time();
		
		$res = ($location == $lcook_data['location']) &&
			   ($server == $lcook_data['server']) &&
			   ($now <= ($lcook_data['issued'] + $this->lcook_data['L_TTL']));
		
		return $res;
	}
	
	public function getLcook() {
		$res = array();
		
		if (array_key_exists($this->name_lcookie, $_COOKIE)) {
			$ciphered = $_COOKIE[$this->name_lcookie];
			$raw = Crypt_AES::decrypt_base64($ciphered, $this->getLkey());
			$tempData = explode(":", $raw);
			$random = array_shift($tempData);
			$timeIssued = array_shift($tempData);
			$location = array_shift($tempData);
			$server = array_shift($tempData);
			$assertion = implode(":", $tempData);
			
			$res = array(
				'random' => $random,
				'issued' => $timeIssued,
				'location' => $location,
				'server' => $server,
				'assertion' => $assertion,
			);
		}
		
		return $res;
	}
}

?>
