<?php
/*
 * Copyright (C) 2010 - PRiSE
 *
 * This	free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

class Reader {

	public static function readParameter($config) {
		$res = '';
		
		if (is_array($config) && array_key_exists('loader_mode',$config)) {
			if ($config['loader_mode'] == 'text' || $config['loader_mode'] == 'array') {
				$res = $config['loader_value'];
			}
			else if ($config['loader_mode'] == 'file') {
				$res = file_get_contents($config['loader_value']);
			}
			else if ($config['loader_mode'] == 'xmlfile') {
				$content = file_get_contents($config['loader_value']);
				$res = array();
				$xml = new SimpleXMLElement($content);
				foreach ($xml->papi_elem as $elem) {
					$id = trim($elem['id']);
					$res[$id] = array();
					foreach ($elem->children() as $child) {
						$name = trim($child->getName());
						$res[$id][$name] = trim($child[0]);
					}
				}
			}
		}
		else {
			$res = $config;
		}
		
		return $res;
	}
}

?>